#include "dll.h"
#include <cstdio>

// ########## BEGIN variables ##########

unsigned long id_bins = 0;
ds_bin *bins = NULL;
ds_bin *selectedbin = NULL;
unsigned long return_x=0,return_y=0,return_z=0;

// ########## BEGIN basic functies ##########

ds_bin* search_bin(unsigned long id) {
	ds_bin *ptr;
	for(ptr=bins;ptr!=NULL;ptr=ptr->next) {
		if(ptr->id==id) return ptr;
	}
	return NULL;
}

ds_bin* create_bin() {
	ds_bin *ptr;
	if(bins==NULL) {
		bins = (ds_bin*) malloc(sizeof(ds_bin));
		if(bins==NULL) return NULL;
		bins->next = NULL;
		return bins;
	} else {
		for(ptr=bins;ptr->next!=NULL;ptr=ptr->next);
		ptr->next = (ds_bin*) malloc(sizeof(ds_bin));
		if(ptr->next==NULL) return NULL;
		ptr->next->next = NULL;
		return ptr->next;
	}
}

void destroy_bin(ds_bin* bin) {
	ds_bin *ptr;
	if(bins==bin) {
		bins = bin->next;
		free(bin);
	} else {
		for(ptr=bins;ptr->next!=bin;ptr=ptr->next);
		ptr->next = bin->next;
		free(bin);
	}
}

inline uint32_t bin_get(ds_bin* bin, unsigned long xx, unsigned long yy, unsigned long zz) {
	unsigned long i = xx+bin->x*yy+bin->x*bin->y*zz;
	if(bin->entriesperword==1) {
		return bin->data[i];
	} else {
		unsigned char j = (bin->entriesperword==1)? 0 : ((i%bin->entriesperword)*bin->bits);
		return (bin->data[i/bin->entriesperword]>>j) & (((uint32_t)(1)<<bin->bits)-1);
	}
}
inline void bin_set(ds_bin* bin, unsigned long xx, unsigned long yy, unsigned long zz, uint32_t val) {
	unsigned long i = xx+bin->x*yy+bin->x*bin->y*zz;
	if(bin->entriesperword==1) {
		bin->data[i] = val;
	} else {
		unsigned char j = (bin->entriesperword==1)? 0 : ((i%bin->entriesperword)*bin->bits);
		uint32_t temp = (((uint32_t)(1)<<bin->bits)-1)<<j;
		bin->data[i/bin->entriesperword] = (bin->data[i/bin->entriesperword] & ~temp) | ((val<<j) & temp);
	}
}

// ########## BEGIN dll functies ##########

#include "basic.h"
#include "cell.h"
#include "region.h"
#include "copy.h"
#include "bin.h"
#include "bin_val.h"
#include "bin_bin.h"

